stages:
  - test
  - build
  - dev

tests:
  stage: test
  image: python:latest
  script:
    - pip install -r requirements.txt
    - flask db upgrade
    - python -m unittest discover

build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  only:
    - main
    - ci
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}"
      --destination "${CI_REGISTRY_IMAGE}:latest"

deploy_to_dev:
  stage: dev
  before_script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - echo "${SSH_PRIVATE_KEY}" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "${SSH_KNOWN_HOSTS}" > ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
    - echo "${DOT_ENV_FILE}" > ./cicd/ansible/files/.env
    - ansible-galaxy install -r cicd/ansible/requirements.yml
    - ansible-playbook cicd/ansible/docker.yml -i cicd/ansible/inventories/dev/hosts -C -vv
    - ansible docker -i cicd/ansible/inventories/dev/hosts -m docker_login -a "username=${CI_REGISTRY_USER} password=${CI_JOB_TOKEN} registry=${CI_REGISTRY}" -C -vv
  script:
    - ansible-playbook cicd/ansible/docker_compose.yml -i cicd/ansible/inventories/dev/hosts -C -vv
  tags:
    - shell
  when: manual
